import Highlight, { IOptions as HighlightOptions } from './Highlight';
import SerializedHighlight from './SerializedHighlight';
interface IOptions {
    snapTableRows?: boolean;
    snapMathJax?: boolean;
    snapWords?: boolean;
    className?: string;
    skipIDsBy?: RegExp;
    onClick?: (highlight: Highlight | undefined, event: MouseEvent) => void;
    onSelect?: (highlights: Highlight[], newHighlight?: Highlight) => void;
}
export default class Highlighter {
    readonly container: HTMLElement;
    private highlights;
    private options;
    constructor(container: HTMLElement, options?: IOptions);
    unmount(): void;
    eraseAll: () => void;
    teardown: () => void;
    erase: (highlight: Highlight) => void;
    highlight(highlight?: Highlight | SerializedHighlight): void;
    getHighlight(id: string): Highlight | undefined;
    getReferenceElement(id: string): HTMLElement | null;
    clearFocus(): void;
    getHighlights(): Highlight[];
    getHighlightOptions(): HighlightOptions;
    getOrderedHighlights(): Highlight[];
    getHighlightBefore(target: Highlight): Highlight | undefined;
    getHighlightAfter(target: Highlight): Highlight | undefined;
    readonly document: Document;
    private onMouseup;
    private onClick;
    private onSelect;
}
export {};
